

;(defun c:din28013 ( / dcl_id breite hoehe X1 X2 X3 X4 Y1 Y2 Y3 Y4 M1 M2 M3
;                   P1 P2 P3 P4 P5 P6
;                   xstart ystart startpkt r1 r2 zw1 zw2 zw3
;                   lda lr1 lr2
;                   norm rechnen obfang)

(defun c:din28013 ()

  (setq lda (list 26.9 30 31.8 33.7 38 42.4 44.5 48.3 51 57 60.3 63.5 70
                  76.1 82.5 88.9 101.6 108 114.3 127 133 139.7 152.4 159
                  168.3 177.8 193.7 219.1 244.5 273 300 323.9 350 355.6
                  400 406.4 450 457 500 508 550 559 600 610 650 660 700
                  711 750 762 800 813 850 864 900 914 950 1000 1016 1050
                  1100 1150 1200 1250 1300 1400 1500 1600 1700 1800 1900
                  2000 2100 2200 2300 2400 2500 2600 2700 2800 2900 3000
                  3100 3200 3300 3400 3500 3600 3700 3800 3900 4000 ))


  (setq lr1 (list 21.5 24 25.5 27 30.4 34 35.6 38.6 40.8 45.5 48 51 56 61
                  66 71 81 86 92 102 106 112 122 125 135 142 155 175 196 218
                  240 254 280 284 320 325 360 365 400 406 440 446 480 488
                  520 528 560 569 600 610 640 650 680 691 720 731 760 800
                  812 840 880 920 960 1000 1040 1120 1200 1280 1360 1440
                  1520 1600 1680 1760 1840 1920 2000 2060 2160 2240 2320
                  2400 2480 2560 2640 2720 2800 2880 2960 3040 3120 3200))

  (setq lr2 (list 4 4.5 5 5 6 6.5 7 7.5 8 9 9.5 10 11 11.5 12.5 14 15.5 16.5
                  17.5 19.5 20.5 21.5 23.5 24.5 26 27 30 34 38 42 46 50 54
                  55 61 62 70 70 77 78 85 86 92 94 100 100 110 110 115 120
                  125 125 130 135 140 140 145 155 155 160 170 175 185 190
                  200 215 230 245 260 280 290 310 325 340 355 370 385 400
                  415 430 445 460 475 490 510 525 540 555 570 585 600 615))


  (if (< (setq dcl_id (load_dialog "ddkorb")) 0)
         (progn
          (alert "DCL - Datei nicht gefunden")
          (exit)
         ) ; Ende progn
  ) ; Ende if

  (if (not (new_dialog "din28013" dcl_id)) (exit))
  (set_tile "da" "1000")
  (set_tile "bhoehe" "50")
  (set_tile "wandd" "3")
  (set_tile "rechnen" "0")
  (set_tile "norm" "1")
  (setq da 1000)
  (setq bhoehe 50)
  (setq wandd 3)
  (setq rechnen 0)
  (setq norm 1)  
  (setq obfang (getvar "OSMODE"))
  (setvar "OSMODE" 0)

  (action_tile "cancel" "(done_dialog)")
  (action_tile "da" "(setq da (atof $Value))")
  (action_tile "bhoehe" "(setq bhoehe (atof $Value))")
  (action_tile "wandd" "(setq wandd (atof $Value))")
  (action_tile "rechnen" "(setq rechnen 1)(setq norm 0)")
  (action_tile "norm" "(setq rechnen 0)(setq norm 1)")

  (setq breite (dimx_tile "bild")
        hoehe  (dimy_tile "bild"))
  (start_image "bild")
  (slide_image 0 0 breite hoehe "din28013")
  (end_image)
  (start_dialog)
  (unload_dialog dcl_id)


  (setq startpkt (getpoint "\nEinfgepunkt whlen: "))
  (setq xstart (car startpkt))
  (setq ystart (car (cdr startpkt)))

  (if (= norm 1)
    (progn
      (print "Die Werte werden aus der Normtabelle genommen!")
      (setq anz (length lda))
      (setq gefunden 0)
      (setq posi 0)
      (while (> anz 0)
         (progn
          (setq zahl (nth anz lda))
          (if (= zahl da)
            (progn
              (setq gefunden 1)
              (setq posi anz)
              (print "GEFUNDEN GEFUNDEN GEFUNDEN")
              (print posi)
             )
            )
          (setq anz (- anz 1))
         )
       )
      (if (= gefunden 0)
         (progn
           (print "Der Auendurchmesser wurde in der Tabelle nicht gefunden!")
           (print "Der Radien werden daher gerechnet!")
           (setq rechnen 1)
         )
         (progn
           (print "Der Auendurchmesser wurde in der Tabelle gefunden!")
           (setq r1 (float (nth posi lr1)))
           (setq r2 (float (nth posi lr2)))
       )
      )
    )
   )



  (if (= rechnen 1)
    (progn
      (print "Die Werte werden berechnet!")
      (setq r1 (* 0.8 da))
      (setq r2 (* 0.154 da))
    )
   )



  (setq r1x xstart)
  (setq zw1 (- r1 r2))
  (setq zw2 (- (/ da 2) wandd r2))
  (setq zw3 (sqrt (- (expt zw1 2) (expt zw2 2))))
  (setq r1y (- ystart zw3))
  (setq dx1 (* (/ zw2 zw1) r1))
  (setq dy1 (* (/ zw3 zw1) r1))
  (setq dx2 (* (/ zw2 zw1) (+ r1 wandd)))
  (setq dy2 (* (/ zw3 zw1) (+ r1 wandd)))
  (setq X1 (+ xstart (- (/ da 2) wandd)))
  (setq Y1 ystart)
  (setq X2 (+ r1x dx1))
  (setq Y2 (+ r1y dy1))
  (setq X3 (- r1x dx1))
  (setq Y3 Y2)
  (setq X4 (- xstart (- (/ da 2) wandd)))
  (setq Y4 Y1)
  (setq p1 (list X1 Y1 0.0))
  (setq p2 (list X2 Y2 0.0))
  (setq p3 (list X3 Y3 0.0))
  (setq p4 (list X4 Y4 0.0))
  (setq M1 (list (+ xstart zw2) ystart 0.0))
  (setq M2 (list r1x r1y 0.0))
  (setq M3 (list (- xstart zw2) ystart 0.0))
  (setq p5 (list X1 (- Y1 bhoehe) 0.0))
  (setq p6 (list X4 (- Y4 bhoehe) 0.0))
  (command "_arc" p1 "_c" M1 p2)
  (command "_arc" p2 "_c" M2 p3)
  (command "_arc" p3 "_c" M3 p4)
  (command "_line" p1 p5 "")
  (command "_line" p4 p6 "")


  (setq X1 (+ xstart (/ da 2)))
  (setq Y1 ystart)
  (setq X2 (+ r1x dx2))
  (setq Y2 (+ r1y dy2))
  (setq X3 (- r1x dx2))
  (setq Y3 Y2)
  (setq X4 (- xstart (/ da 2)))
  (setq Y4 Y1)
  (setq p1 (list X1 Y1 0.0))
  (setq p2 (list X2 Y2 0.0))
  (setq p3 (list X3 Y3 0.0))
  (setq p4 (list X4 Y4 0.0))
  (setq p5 (list X1 (- Y1 bhoehe) 0.0))
  (setq p6 (list X4 (- Y4 bhoehe) 0.0))
  (command "_arc" p1 "_c" M1 p2)
  (command "_arc" p2 "_c" M2 p3)
  (command "_arc" p3 "_c" M3 p4)
  (command "_line" p1 p5 "")
  (command "_line" p4 p6 "")
  (command "_line" p1 p4 "")
  (command "_line" p5 p6 "")
  (setvar "OSMODE" obfang)
)

(princ "mit din28013 starten!")
